#include <freehdl/kernel-sigacl-list.hh>


sigacl_list::sigacl_list(int size) {
  count = 0;
  list = new _items[size];
  list_size = size;
}


sigacl_list::~sigacl_list() {
  if (list == NULL) return;
  for (int i = 0; i < count; i++)
    if (list[i].aclp != NULL)
      delete list[i].aclp;
  delete[] list;
}


void
sigacl_list::add(sig_info_base *s, acl *a) {
  if (count >= list_size)
  {
    std::cout << "WARNING: sigacl_list::add()" << "\n" << "list index greater than list length\n" ;
    return;
  }

  list[count].signal = s;
  if (a != NULL) list[count].aclp = a->clone();
  else list[count].aclp = NULL;
  count++;
}


